Attribute VB_Name = "modArrayHandling"


'ArrayHandling Module

Option Explicit

Public Function Push2DStrArrayToArray(ByVal sString1 As String, ByVal sString2 As String, ByRef a_vArray(), Optional iExistingIndex As Long = -1)
    Dim a_vTempArray()
    If iExistingIndex = -1 Then
        If IsArrayEmpty(a_vArray) = True Then
            ReDim a_vArray(0)
            ReDim a_vTempArray(1)
            a_vTempArray(0) = VBA.Trim(sString1)
            a_vTempArray(1) = VBA.Trim(sString2)
            a_vArray(0) = a_vTempArray
        Else
            ReDim Preserve a_vArray(UBound(a_vArray) + 1)
            ReDim a_vTempArray(1)
            a_vTempArray(0) = sString1
            a_vTempArray(1) = sString2
            a_vArray(UBound(a_vArray)) = a_vTempArray
        End If
    Else
        ReDim a_vTempArray(1)
        a_vTempArray(0) = sString1
        a_vTempArray(1) = sString2
        a_vArray(iExistingIndex) = a_vTempArray 'if there is an error on this line because the index was out of bounds, then you should have checked outside of this function - this part of the code is only intendid to replace existing index content
    End If
End Function

Public Function Get2DArrDataByIndx1StrMatch(ByRef a_vArray(), sIndex1Text As String, iSubIndex As Long, Optional bCaseSensitive As Boolean = False) As Variant
    Dim a_sTempArray As Variant, vReturn As Variant, i As Long, sSearch As String, sBuffer As String
    If IsArrayEmpty(a_vArray) = False Then
        If bCaseSensitive = False Then
            sSearch = VBA.LCase(VBA.Trim(sIndex1Text))
        Else
            sSearch = VBA.Trim(sIndex1Text)
        End If
        For i = 0 To UBound(a_vArray)
            a_sTempArray = a_vArray(i)
            If bCaseSensitive = False Then
                sBuffer = VBA.LCase(VBA.Trim(a_sTempArray(0)))
            Else
                sBuffer = VBA.Trim(a_sTempArray(0))
            End If
            If sSearch = sBuffer Then
                vReturn = a_sTempArray(iSubIndex)
                Exit For
            End If
        Next i
    End If
    Get2DArrDataByIndx1StrMatch = vReturn
End Function

Public Function Get2DArrDataByIndx1StrMatchIndx(ByRef a_vArray(), sIndex1Text As String, Optional bCaseSensitive As Boolean = False) As Variant
    Dim a_sTempArray, iReturn As Variant, i As Long, sSearch As String, sBuffer As String
    iReturn = -1
    If IsArrayEmpty(a_vArray) = False Then
        If bCaseSensitive = False Then
            sSearch = VBA.LCase(VBA.Trim(sIndex1Text))
        Else
            sSearch = VBA.Trim(sIndex1Text)
        End If
        For i = 0 To UBound(a_vArray)
            a_sTempArray = a_vArray(i)
            If bCaseSensitive = False Then
                sBuffer = VBA.LCase(VBA.Trim(a_sTempArray(0)))
            Else
                sBuffer = VBA.Trim(a_sTempArray(0))
            End If
            If sSearch = sBuffer Then
                iReturn = i
                Exit For
            End If
        Next i
    End If
    Get2DArrDataByIndx1StrMatchIndx = iReturn
End Function

'a_vBuffer = Rtrn2DArrArrResults(sBuffer, a_sArray(), 0)
Public Function Rtrn2DArrArrResults(sCurrentName, a_sArray(), iIndexToSearch) As Variant()
    Dim a_TempArray(), a_vReturn(), i As Long

    If IsArrayEmpty(a_sArray) = False Then
        For i = LBound(a_sArray) To UBound(a_sArray)
            ReDim a_TempArray(1)
            a_TempArray = a_sArray(i)
            If a_TempArray(iIndexToSearch) = sCurrentName Then
                If IsArrayEmpty(a_vReturn) = True Then
                    ReDim a_vReturn(0)
                    a_vReturn(0) = a_TempArray
                Else
                    ReDim Preserve a_vReturn(UBound(a_vReturn) + 1)
                    a_vReturn(UBound(a_vReturn)) = a_TempArray
                End If
            End If
        Next i
    End If
    Rtrn2DArrArrResults = a_vReturn
End Function

Function IsArrayEmpty(aArray As Variant) As Boolean
    Dim i As Long
    On Error Resume Next
        i = UBound(aArray, 1)
    If Err.Number = 0 Then
        IsArrayEmpty = False
    Else
        IsArrayEmpty = True
    End If
    Err.Clear
    On Error GoTo 0
End Function

Sub PushIntPairToArrays(iStart As Long, iEnd As Long, bPushToCommentsArr As Boolean, ByRef a_iIgnoreBounds(), ByRef a_iCommentsOnly())
    Dim a_iPair()
    ReDim a_iPair(1)
    a_iPair(0) = iStart
    a_iPair(1) = iEnd
    Push2IndexArrToArr a_iPair, a_iIgnoreBounds
    If bPushToCommentsArr = True Then
        Push2IndexArrToArr a_iPair, a_iCommentsOnly
    End If
End Sub

Public Function Push2IndexArrToArr(ByRef a_vNewInfo(), ByRef a_vDestArray())
    If IsArrayEmpty(a_vDestArray) = True Then
        ReDim a_vDestArray(0)
        a_vDestArray(0) = a_vNewInfo
    Else
        ReDim Preserve a_vDestArray(UBound(a_vDestArray) + 1)
        a_vDestArray(UBound(a_vDestArray)) = a_vNewInfo
    End If
End Function

Public Sub PushArrayString(ByVal sString As String, ByRef a_sArray())
    If IsArrayEmpty(a_sArray) = True Then
        ReDim a_sArray(0)
        a_sArray(0) = sString
    Else
        ReDim Preserve a_sArray(UBound(a_sArray) + 1)
        a_sArray(UBound(a_sArray)) = sString
    End If
End Sub

'Function IsStringInArray(sName As String, ByRef aArray()) As Boolean
'    Dim i As Long, bReturn As Boolean
'    bReturn = False
'    If IsArrayEmpty(aArray) = False Then
'        For i = 0 To UBound(aArray)
'            If sName = aArray(i) Then
'                bReturn = True
'                Exit For
'            End If
'        Next i
'    End If
'
'    IsStringInArray = bReturn
'End Function

Function FindStringIndxInArray(sName As String, ByRef aArray()) As Long
    Dim i As Long, iReturn As Long
    iReturn = -1
    If IsArrayEmpty(aArray) = False Then
        For i = 0 To UBound(aArray)
            If sName = aArray(i) Then
                iReturn = i
                Exit For
            End If
        Next i
    End If

    FindStringIndxInArray = iReturn
End Function


