Attribute VB_Name = "modConvert"


'Convert Module

'TO DO:
    'Find expressions or variables that are coerced to data types and replace with view_as<type>()
        'must be inside function, not in header
    
'POTENTIAL TO DO:
    'Replacing code with new SP 1.8 classes
        'Do this on a second pass through the destination file?
        'Or rather do this on first, but have second pass for removing unused cvar caches
    'compile from within plugin and read errors?
    'Optimize code efficiency
        'Remove function types that DNE in SP 1.6- (1.8 classes)
        'Make variables created inside checks - not for entire function. Cleaner, easier, can rename there, etc.


    
'////////////////////////////////////////////////////////////////////////
'////////////////////////////////////////////////////////////////////////
'////////////////////////////////////////////////////////////////////////

Option Explicit

Public g_bMLComment As Boolean, g_bMLCommentPrevLine As Boolean, g_iLineNum As Long, g_iOpenBracketCount As Long, g_sNextLine As String, g_sIncludePath As String, g_bIsFunctionHeader As Boolean
Public gaa_iIgnoreBounds(), gaa_iCommentsOnly(), ga_sNativeFunctionNames(), a_sOutputLines()
Public ga_sTypes(), ga_sIncludeNames(), ga_sNumericDefinedSizes(), gaa_sFwdNames(), gaa_sGlobalVariables()
Const ForReading = 1, ForWriting = 2

Public Default_Path As String
Public Includes_Path As String

Sub Main()
    Dim argv() As String
    Dim argc As Long

    ParseCommandLine Command(), argc, argv

    If argc > 0 Then
        If argc = 1 Then
            Default_Path = UnQuote(argv(1))
        ElseIf argc = 2 Then
            Includes_Path = UnQuote(argv(1))
            Default_Path = UnQuote(argv(2))
        Else
            MsgBox "Incorrect number of arguments"
            Exit Sub
        End If
    Else
        MsgBox "Incorrect number of arguments"
        Exit Sub
    End If
    
'    Includes_Path = "D:\dev\SourceMod\addons\sourcemod\scripting\include"
'    Default_Path = "H:\_To_games\Left4Dead_2\My_mods\Tank\Convert\New\Lbt.sp"

    ConvertPlugin
End Sub

Public Function UnQuote(str As String) As String   ' Trim quotes
    If Len(str) = 0 Then Exit Function
    If Left$(str, 1) = """" And Right$(str, 1) = """" Then
        UnQuote = Mid$(str, 2, Len(str) - 2)
    Else
        UnQuote = str
    End If
End Function


Public Function ParseCommandLine(Line As String, argc As Long, argv() As String) As Boolean
  Dim Lex$(), nL&, nA&, Unit$, St$
  St = Line
  If Len(St) > 0 Then ParseCommandLine = True
  Lex = Split(St) '       
  ReDim argv(0 To UBound(Lex) + 1) As String '       
  argv(0) = App.Path
  If Len(St) <> 0 Then
    Do While nL <= UBound(Lex)
      Unit = Lex(nL) '      
      If Len(Unit) <> 0 Then '     
        '        ,    ""
        If (Len(Lex(nL)) - Len(Replace$(Lex(nL), """", ""))) Mod 2 = 1 Then
          Do
            nL = nL + 1
            If nL > UBound(Lex) Then Exit Do '    ,    
            Unit = Unit & " " & Lex(nL) '  
          '    1             (  )
          Loop Until (Len(Lex(nL)) - Len(Replace$(Lex(nL), """", ""))) Mod 2 = 1
        End If
        Unit = Replace$(Unit, """", "") ' 
        nA = nA + 1 ' -  
        argv(nA) = Unit
      End If
      nL = nL + 1 '  
    Loop
  End If
  ReDim Preserve argv(0 To nA) '      
  argc = nA
End Function

Sub ConvertPlugin()
    Dim sFilePath As String

    If Default_Path <> vbNullString Then
        If FileFolderExists(Default_Path) = True Then
            ChDrive Left(Default_Path, 3)
            ChDir GetParentDir(Default_Path)
        End If
    End If
    
    sFilePath = Default_Path
    Call Convert(sFilePath) 'separated out to allow for recursive processing/conversion of includes, should that be added in the future as an option

End Sub

Public Function GetParentDir(sPath As String) As String
    Dim pos As Long
    pos = InStrRev(sPath, "\")
    If pos <> 0 Then
        GetParentDir = Left$(sPath, pos - 1)
    End If
End Function

Sub Convert(sFilePath As String)
    Dim sNewPath As String, sFolder As String, i As Long, sFileNameNoExt As String, bFirstLine As Boolean
    Dim sBuffer As String, sRtn As String, iOutputFile As Long, iInputFile, oFSO As Object, oSrcFile As Object, oDestFile As Object
    
    'initialize
    g_bMLComment = False
    g_bMLCommentPrevLine = False
    g_iLineNum = 0
    g_iOpenBracketCount = 0
    g_sNextLine = vbNullString
    bFirstLine = True
    'including this in case the script errors out for whatever reason, it would mess up the next run
    Erase gaa_iIgnoreBounds
    Erase gaa_iCommentsOnly
    Erase ga_sNativeFunctionNames
    Erase ga_sTypes
    Erase ga_sIncludeNames
    Erase ga_sNumericDefinedSizes
    Erase gaa_sFwdNames
    Erase a_sOutputLines
    Erase gaa_sGlobalVariables
    
    Call CreateFunctionArray
    Call Create2DFwdsArray
    Call CreateNumericSizeDefinesArray
    
    'On Error GoTo 0
    sFolder = GetPathFromFullPath(sFilePath)
    sFileNameNoExt = GetFilenameFromPath_NoExt(sFilePath)
    sNewPath = sFolder & sFileNameNoExt & " newsyntax.sp"
    i = 1   'this will start it at 2
    If Dir(sNewPath) <> vbNullString Then
        Do Until Dir(sNewPath) = vbNullString
            i = i + 1
            sNewPath = sFolder & sFileNameNoExt & " newsyntax " & i & ".sp"
        Loop
    End If
    g_sIncludePath = Includes_Path
    If g_sIncludePath <> vbNullString Then
        If VBA.Right(g_sIncludePath, 1) <> "\" And VBA.Right(g_sIncludePath, 1) <> "/" Then
            g_sIncludePath = g_sIncludePath & "\"
        End If
    End If
    
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    Set oSrcFile = oFSO.OpenTextFile(sFilePath, ForReading)
    Set oDestFile = oFSO.OpenTextFile(sNewPath, ForWriting, True)
    
    oDestFile.WriteLine "/* put the line below after all of the includes!" & vbNewLine & "#pragma newdecls required" & vbNewLine & "*/" & vbNewLine
    
    'lag the processing by one line in order to make the next line available during the analysis
    Do Until oSrcFile.AtEndOfStream
        sBuffer = g_sNextLine
        g_sNextLine = oSrcFile.ReadLine
        g_iLineNum = g_iLineNum + 1
        If g_iLineNum = 1529 Then    'this is only here to provide a break point to debug specific locations
            'Debug.Print ""     'uncomment to use as a breakpoint
        End If
        'Form1.StatusBar.SimpleText = "Processing line: " & g_iLineNum - 1
        If bFirstLine = False Then
            'sRtn = ProcessLine(sBuffer)
            'oDestFile.WriteLine sRtn
            Call PushArrayString(ProcessLine(sBuffer), a_sOutputLines)
            g_bMLCommentPrevLine = g_bMLComment
            If g_iOpenBracketCount = 0 And g_bIsFunctionHeader = False Then
                For i = 0 To UBound(a_sOutputLines)
                    oDestFile.WriteLine a_sOutputLines(i)
                Next i
                Erase a_sOutputLines
            End If
        Else
            bFirstLine = False
        End If
    Loop
    sBuffer = g_sNextLine
    g_sNextLine = vbNullString    'set to null so that processing doesnt read it as if there is another line
    Call PushArrayString(ProcessLine(sBuffer), a_sOutputLines)  'process last line
    For i = 0 To UBound(a_sOutputLines)
        oDestFile.WriteLine a_sOutputLines(i)
    Next i

    'cleanup
    oSrcFile.Close
    oDestFile.Close

    Erase gaa_iIgnoreBounds
    Erase gaa_iCommentsOnly
    Erase ga_sNativeFunctionNames
    Erase ga_sTypes
    Erase ga_sIncludeNames
    Erase ga_sNumericDefinedSizes
    Erase gaa_sFwdNames
    Erase a_sOutputLines
    Erase gaa_sGlobalVariables
    
    Set oFSO = Nothing
    Set oSrcFile = Nothing
    Set oDestFile = Nothing
    
    'MsgBox "Conversion complete! " & g_iLineNum & " Lines Processed!"
    'Form1.StatusBar.SimpleText = g_iLineNum & " Lines Processed!"
End Sub

Function ProcessLine(sOrigString As String) As String
    Dim sTrimmedString As String, sReturn As String, sBuffer As String, sbuffer2 As String, a_sSplit() As String, a_sSplit2() As String, sIndents As String
    Dim iBuffer As Long, iBuffer2 As Long, iBuffer3 As Long, i As Long, j As Long, bMenuHandler As Boolean, bBuffer As Boolean, sConvComm As String
    sReturn = sOrigString
    sTrimmedString = Trim2(sOrigString)
    sIndents = GetLeadingIndents(sReturn)
    g_bIsFunctionHeader = False
    bMenuHandler = False
    sConvComm = vbNullString
    'debug.print g_iOpenBracketCount
    If VBA.Left(sTrimmedString, 1) <> "#" Then   'skip processing pre-compilation statements
        If sTrimmedString <> vbNullString Then   'skip processing blank lines
            Call GetIgnoreSections(sReturn, gaa_iIgnoreBounds, gaa_iCommentsOnly)
            If Not ((g_bMLCommentPrevLine = True) And (VBA.InStr(sOrigString, "*/") = 0)) Then   'if ML comment from previous line that does not end on this line - skip processing
                If Not ((g_bMLComment = True) And (VBA.InStr(sOrigString, "*/") = 0)) Then    'if ML comment now that does not end on this line - skip processing

                    '/////////////////////////////////////////////
                    '/ Initial filters complete! Process line... /
                    '/////////////////////////////////////////////
                    
                    If IsFunctionHeader(sOrigString) = True Then   'doesnt end in ; or { and next line isnt { or cond compile statement
                        g_bIsFunctionHeader = True
                        'sReturn = HandleHeaderCharParams(sReturn)   'these needs to happen before replacement of String: with char
                        'Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    Else
                        g_bIsFunctionHeader = False
                    End If
                    
                    'TO DO: find coerced types and convert to view_as<type>().
                    'look for : (colon) not in ignore section and without ? (ternary)
                    'need to ignore "case" (select statements) situation
                    'need to do this before replacing the :'s
                    
                    sReturn = MakeReplacement(sReturn, "String:", "char ", True, 0, gaa_iIgnoreBounds)
                    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    sReturn = MakeReplacement(sReturn, "Float:", "float ", True, 0, gaa_iIgnoreBounds)
                    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    
                    For i = 0 To UBound(ga_sTypes)
                        sReturn = MakeReplacement(sReturn, ga_sTypes(i) & ":", ga_sTypes(i) & " ", True, 0, gaa_iIgnoreBounds)
                        Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    Next i
                    
                    sReturn = MakeReplacement(sReturn, "new ", "int ", False, 0, gaa_iIgnoreBounds)
                    sReturn = MakeReplacement(sReturn, "decl ", "int ", False, 0, gaa_iIgnoreBounds)
                    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    
                    'remove/replace depreciated code
                    sReturn = VBA.Replace(sReturn, "FCVAR_PLUGIN|", vbNullString)
                    sReturn = VBA.Replace(sReturn, "|FCVAR_PLUGIN", vbNullString)
                    sReturn = VBA.Replace(sReturn, "FCVAR_PLUGIN", "_")
                    sReturn = VBA.Replace(sReturn, "FindSendPropOffs", "FindSendPropInfo")
                    'sReturn = VBA.Replace(sReturn, "INVALID_HANDLE", "null")
                    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    
                    If VBA.InStr(sReturn, "GetClientAuthString") > 0 Then
                        ''GetClientAuthString(client, sID, sizeof(sID));
                        'GetClientAuthId(client, AuthId_Steam2, sID, sizeof(sID));
                        iBuffer = VBA.InStr(sReturn, "(")
                        iBuffer2 = VBA.InStr(sReturn, ",")
                        sBuffer = VBA.Mid(sReturn, iBuffer + 1, iBuffer2 - iBuffer - 1)
                        sReturn = sIndents & "GetClientAuthId(" & sBuffer & ", AuthId_Steam2" & VBA.Mid(sReturn, iBuffer2)
                    End If
                    
                    If g_bIsFunctionHeader = True Then
                        iBuffer = VBA.InStr(sReturn, "(")
                        If iBuffer > 0 Then
                            'handle params
                            iBuffer = VBA.InStr(sReturn, "(")
                            iBuffer2 = VBA.InStr(sReturn, ")")
                            If iBuffer + 1 < iBuffer2 Then  'if there are parameters - assumes no random space between
                                sBuffer = VBA.Mid(sReturn, iBuffer + 1, iBuffer2 - iBuffer - 1)
                                a_sSplit = VBA.Split(sBuffer, ",")
                                For i = 0 To UBound(a_sSplit)
                                    If i = 1 Then
                                        If VBA.InStr(a_sSplit(i), "MenuAction ") > 0 Then
                                            bMenuHandler = True
                                        End If
                                    End If
                                    
                                    Dim sDefaultVal As String
                                    If VBA.InStr(Trim2(a_sSplit(i)), "=") > 0 Then
                                        sDefaultVal = Trim2(VBA.Mid(Trim2(a_sSplit(i)), VBA.InStr(Trim2(a_sSplit(i)), "=") + 1))
                                        a_sSplit(i) = Trim2(VBA.Left(Trim2(a_sSplit(i)), VBA.InStr(Trim2(a_sSplit(i)), "=") - 1)) 'this will be added back later
                                    Else
                                        sDefaultVal = vbNullString
                                    End If
                                    
                                    If VBA.InStr(Trim2(a_sSplit(i)), " ") = 0 Then   'if only one word, therefor int needs to be added
                                        If i = 0 Then
                                            a_sSplit(i) = "int " & Trim2(a_sSplit(i))
                                        Else
                                            a_sSplit(i) = " int " & Trim2(a_sSplit(i))
                                        End If
                                    Else    'more than 1 word
                                        a_sSplit2 = VBA.Split(Trim2(a_sSplit(i)), " ")
                                        If UBound(a_sSplit2) = 1 Then
                                            If a_sSplit2(0) = "const" Then
                                                a_sSplit(i) = "const int"
                                                For j = 1 To UBound(a_sSplit2)
                                                    a_sSplit(i) = a_sSplit(i) & " " & Trim2(a_sSplit2(j))
                                                Next j
                                            End If
                                        End If
                                    End If
                                    a_sSplit2 = VBA.Split(Trim2(a_sSplit(i)), " ")
                                    If VBA.InStr(Trim2(a_sSplit(i)), "[]") > 0 Then
                                        Dim iNumBrackets As Long, iLoc As Long
                                        iLoc = 0
                                        iNumBrackets = 0
                                        iLoc = VBA.InStr(iLoc + 1, Trim2(a_sSplit(i)), "[]")
                                        Do While iLoc > 0
                                            iNumBrackets = iNumBrackets + 1
                                            iLoc = VBA.InStr(iLoc + 1, Trim2(a_sSplit(i)), "[]")
                                        Loop
                                        If VBA.InStr(Trim2(a_sSplit(i)), "const") = 1 Then
                                            a_sSplit(i) = "const " & a_sSplit2(1)
                                            For j = 1 To iNumBrackets
                                                a_sSplit(i) = a_sSplit(i) & "[]"
                                            Next j
                                            For j = 2 To UBound(a_sSplit2)
                                                a_sSplit(i) = a_sSplit(i) & " " & VBA.Replace(Trim2(a_sSplit2(j)), "[]", vbNullString)
                                            Next j
                                        Else
                                            a_sSplit(i) = a_sSplit2(0)
                                            For j = 1 To iNumBrackets
                                                a_sSplit(i) = a_sSplit(i) & "[]"
                                            Next j
                                            For j = 1 To UBound(a_sSplit2)
                                                a_sSplit(i) = a_sSplit(i) & " " & VBA.Replace(Trim2(a_sSplit2(j)), "[]", vbNullString)
                                            Next j
                                        End If
                                    End If
                                    If sDefaultVal <> vbNullString Then
                                        a_sSplit(i) = a_sSplit(i) & " = " & sDefaultVal
                                    End If
                                Next i
                                sbuffer2 = vbNullString
                                For i = 0 To UBound(a_sSplit)
                                    If i = 0 Then
                                        sbuffer2 = sbuffer2 & Trim2(a_sSplit(i))
                                    Else
                                        sbuffer2 = sbuffer2 & ", " & Trim2(a_sSplit(i))
                                    End If
                                Next i
                                sReturn = VBA.Replace(sReturn, "(" & sBuffer & ")", "(" & sbuffer2 & ")")
                            End If
                            Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                            
                            'add declaration of function type
                            sBuffer = VBA.Left(sReturn, iBuffer - 1)
                            a_sSplit = VBA.Split(sBuffer, " ")
                            If UBound(a_sSplit) = 0 Then    'only 1 word
                                sbuffer2 = GetFunctionType(a_sSplit(0), bMenuHandler)
                                sReturn = VBA.Replace(sReturn, sBuffer & "(", sbuffer2 & " " & sBuffer & "(")
                            Else
                                iBuffer2 = 0
                                For i = 0 To UBound(a_sSplit)
                                    If (a_sSplit(i) <> "public") And (a_sSplit(i) <> "stock") Then   'if only one word
                                        iBuffer2 = iBuffer2 + 1
                                    End If
                                Next i
                                If iBuffer2 < 2 Then
                                    sbuffer2 = vbNullString
                                    For j = 0 To UBound(a_sSplit)
                                        If j = 0 Then
                                            sbuffer2 = a_sSplit(j)
                                        ElseIf j <> UBound(a_sSplit) Then   'if middle word
                                            sbuffer2 = sbuffer2 & " " & a_sSplit(j)
                                        Else    'last word - assumed to be function name
                                            Dim sType As String
                                            sType = GetFunctionType(a_sSplit(j), bMenuHandler)
                                            sbuffer2 = sbuffer2 & " " & sType & " " & a_sSplit(j)
                                        End If
                                    Next j
                                    sReturn = VBA.Replace(sReturn, sBuffer & "(", sbuffer2 & "(")
                                End If
                            End If
                        End If
                        
                    Else    'NOT A FUNCTION HEADER LINE
                    
                        Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                        
'                        'find lines with = split on it.
'                        'then split again on space and check each word for types that may be being coerced
'                        If g_iOpenBracketCount > 0 Then
'                            sBuffer = Trim2(StripComments(sReturn, gaa_iCommentsOnly))
'                            iBuffer = VBA.InStr(sBuffer, "=")
'                            If iBuffer > 0 Then
'                                'first we 'll check if we find a variable type being coerced
'                                bBuffer = False
'                                sBuffer = VBA.Mid(sBuffer, iBuffer + 1)
'                                a_sSplit = SplitWithMultipleDelimiters(sBuffer, " ", True)
'                                For i = 0 To UBound(a_sSplit)
'                                    If FindStringIndxInArray(a_sSplit(i), ga_sTypes) <> -1 Then
'                                        bBuffer = True
'                                        Exit For
'                                    End If
'                                Next i
'                                If bBuffer = True Then
'                                    sConvComm = vbTab & vbTab & "//This line appears to have a variable being coerced to another type. Change this to view_as<type>(value). e.g. fFloat = Float:iSomeInt; --> fFloat = view_as<float>(iSomeInt);"
'                                End If
'                                'Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
'                            End If
'                        End If
                        
                        'Break apart lines where variables of multiple types are declared
                        Dim sReturnOverride As String, a_sReturn(), sComments As String
                        If (VBA.InStr(sReturn, ",") > 0) Then
                            If (VBA.InStr(sReturn, "=") = 0) And (VBA.InStr(sReturn, "<") = 0) And (VBA.InStr(sReturn, ">") = 0) And (VBA.InStr(sReturn, "!") = 0) And (VBA.InStr(sReturn, "(") = 0) Then
                                bBuffer = False 'only going to replace if the entire line is variable declarations
                                'get indents
                                sIndents = GetLeadingIndents(sReturn)
                                If VBA.InStr(sReturn, "//") > 0 Then
                                    sComments = VBA.Mid(sReturn, VBA.InStr(sReturn, "//"))
                                Else
                                    sComments = vbNullString
                                End If
                                sBuffer = Trim2(VBA.Replace(VBA.Replace(sReturn, ";", vbNullString), sComments, vbNullString))
                                'split remaining
                                If sBuffer <> vbNullString Then
                                    a_sSplit = VBA.Split(sBuffer, ",", True)
                                    a_sSplit2 = VBA.Split(Trim2(a_sSplit(0)), " ")
                                    If FindStringIndxInArray(a_sSplit2(0), ga_sTypes) <> -1 Then  'if valid type
                                        bBuffer = True  'assume all are declarations until found otherwise
                                        sReturnOverride = a_sSplit2(0)  'the first one should be two words, though following ones may not be
                                        For i = 1 To UBound(a_sSplit2)
                                            sReturnOverride = sReturnOverride & " " & a_sSplit2(i)
                                        Next i
                                        Erase a_sReturn
                                        Call Push2DStrArrayToArray(a_sSplit2(0), sReturnOverride, a_sReturn)
                                        For i = 1 To UBound(a_sSplit)   'skip first index for the loop
                                            a_sSplit2 = VBA.Split(Trim2(a_sSplit(i)), " ")  'outsides of each split are trimmed
                                            iBuffer = UBound(a_sSplit2)
                                            'currently doesnt support splitting rows where an array is dimensioned with spaces in the brackets
                                            'e.g. char a_sSomeString[ MAXPLAYERS + 1 ][ 32 ]. or even int a_sSomeString[ MAXPLAYERS + 1 ]
                                            If iBuffer = 1 Then '2 words
                                                If FindStringIndxInArray(a_sSplit2(0), ga_sTypes) <> -1 Then
                                                    sReturnOverride = Get2DArrDataByIndx1StrMatch(a_sReturn, a_sSplit2(0), 1)
                                                    If sReturnOverride = vbNullString Then      'new type
                                                        sReturnOverride = Trim2(a_sSplit(i))    'get whole thing without subsplit - use first split arr
                                                        Call Push2DStrArrayToArray(a_sSplit2(0), sReturnOverride, a_sReturn)
                                                    Else
                                                        sReturnOverride = sReturnOverride & ", " & a_sSplit2(1)
                                                        iBuffer = Get2DArrDataByIndx1StrMatchIndx(a_sReturn, a_sSplit2(0))  'get index to put it back in
                                                        Call Push2DStrArrayToArray(a_sSplit2(0), sReturnOverride, a_sReturn, iBuffer)
                                                    End If
                                                Else
                                                    bBuffer = False 'invalid, cancel override
                                                    Exit For
                                                End If
                                            ElseIf iBuffer = 0 Then    'int
                                                sReturnOverride = Get2DArrDataByIndx1StrMatch(a_sReturn, "int", 1)
                                                If sReturnOverride = vbNullString Then      'new type
                                                    sReturnOverride = "int " & Trim2(a_sSplit2(0))
                                                    Call Push2DStrArrayToArray("int", sReturnOverride, a_sReturn)
                                                Else
                                                    sReturnOverride = sReturnOverride & ", " & Trim2(a_sSplit2(0))
                                                    iBuffer = Get2DArrDataByIndx1StrMatchIndx(a_sReturn, "int")  'get index to put it back in
                                                    Call Push2DStrArrayToArray("int", sReturnOverride, a_sReturn, iBuffer)
                                                End If
                                            Else    'more than 2 words...may just be a size in brackets with spaces though...
                                                iBuffer = VBA.InStr(Trim2(a_sSplit(i)), "[")   'checking if brackets are the reason for the third word...could be like: char a_sSomeString[MAXPLAYERS + 1]
                                                If iBuffer = 0 Then
                                                    bBuffer = False 'invalid, cancel override
                                                    Exit For
                                                End If
                                                iBuffer2 = VBA.InStr(Trim2(a_sSplit(i)), "]")
                                                sBuffer = VBA.Mid(Trim2(a_sSplit(i)), iBuffer + 1, iBuffer2 - iBuffer - 1)    'get text between brackets
                                                If FindStringIndxInArray(a_sSplit2(0), ga_sTypes) <> -1 Then
                                                    iBuffer3 = VBA.InStr(a_sSplit2(0) & " " & a_sSplit2(1), VBA.Left(Trim2(a_sSplit(i)), iBuffer)) 'check if there is other stuff between with additional spaces
                                                    If iBuffer3 = 0 Then
                                                        bBuffer = False 'invalid, cancel override
                                                        Exit For
                                                    End If
                                                    If Trim2(a_sSplit(i)) <> VBA.Left(Trim2(a_sSplit(i)), iBuffer) & sBuffer & "]" Then
                                                        bBuffer = False 'invalid, cancel override
                                                        Exit For
                                                    Else
                                                        sReturnOverride = Get2DArrDataByIndx1StrMatch(a_sReturn, a_sSplit2(0), 1)
                                                        If sReturnOverride = vbNullString Then      'new type
                                                            sReturnOverride = Trim2(a_sSplit(i))    'get whole thing without subsplit - use first split arr
                                                            Call Push2DStrArrayToArray(a_sSplit2(0), sReturnOverride, a_sReturn)
                                                        Else
                                                            sReturnOverride = sReturnOverride & ", " & VBA.Mid(Trim2(a_sSplit(i)), VBA.InStr(Trim2(a_sSplit(i)), " ") + 1)
                                                            iBuffer = Get2DArrDataByIndx1StrMatchIndx(a_sReturn, a_sSplit2(0))  'get index to put it back in
                                                            Call Push2DStrArrayToArray(a_sSplit2(0), sReturnOverride, a_sReturn, iBuffer)
                                                        End If
                                                    End If
                                                Else
                                                    bBuffer = False 'invalid, cancel override
                                                    Exit For
                                                End If
                                            End If
                                        Next i
                                    End If
                                End If
                            End If
                        End If
                        If bBuffer = True Then
                            For i = 0 To UBound(a_sReturn)
                                Dim a_sBuffer()
                                a_sBuffer = a_sReturn(i)
                                If i = 0 Then
                                    sReturn = sIndents & a_sBuffer(1) & ";" & sComments
                                Else
                                    If i < UBound(a_sBuffer) Then
                                        sReturn = sReturn & vbNewLine & sIndents & a_sBuffer(i) & ";"
                                    End If
                                End If
                            Next i
                            Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)    'Update "ignore" sections after replacement
                        Else    'these are handled above if it makes it through all the checks...else we handle here
                            'check for multiple char in a line
                            iBuffer = VBA.InStr(sReturn, "char") + 1
                            If VBA.InStr(iBuffer, sReturn, "char") > 0 Then
                                sReturn = MakeReplacement(sReturn, "char ", vbNullString, False, iBuffer, gaa_iIgnoreBounds)
                                Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                            End If
                            
                            iBuffer = VBA.InStr(sReturn, "float") + 1
                            If VBA.InStr(iBuffer, sReturn, "float") > 0 Then
                                sReturn = MakeReplacement(sReturn, "float ", vbNullString, False, iBuffer, gaa_iIgnoreBounds)
                                Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                            End If
                        End If
                        Erase a_sReturn

                        'edit dynamic (runtime defined) string sizes to work for new syntax
                        
                        'e.g.   'decl String:sTempArray[iStrCount][30];                 <<old syntax
                                'char sTempArray[iStrCount][30];                        <<current status
                                'char[][] a_sTempArray = new char[iStrCount][30];       <<new syntax
                                
'                        iBuffer = VBA.InStr(sReturn, "char ")
'                        If iBuffer > 0 Then
'                            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
'                                Dim a_sBracketContents(), iEnd As Long, iCount As Long
'                                bBuffer = False
'                                iBuffer = VBA.InStr(sReturn, "[")
'                                Do While ((iBuffer > 0) And (IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False))
'                                    iBuffer2 = VBA.InStr(iBuffer + 1, sReturn, "]")
'                                    If iBuffer2 > 0 Then
'                                        iEnd = iBuffer2
'                                    End If
'                                    sBuffer = VBA.Mid(sReturn, iBuffer + 1, iBuffer2 - iBuffer - 1)
'                                    Call PushArrayString(sBuffer, a_sBracketContents)
'                                    iCount = iCount + 1
'                                    If VBA.IsNumeric(sBuffer) = False Then
'                                        If IsDynamicSize(sBuffer) = True Then
'                                            bBuffer = True
'                                        End If
'                                    End If
'                                    iBuffer = VBA.InStr(iBuffer2 + 1, sReturn, "[")
'                                Loop
'                                If bBuffer = True Then
'                                    iBuffer = VBA.InStr(sReturn, "char ")   'find start
'                                    sBuffer = Left(sReturn, iBuffer + 3)    'end after char, before space
'                                    For i = 1 To iCount
'                                        sBuffer = sBuffer & "[]"
'                                    Next i
'                                    sBuffer = sBuffer & " "
'                                    'get variable name
'                                    iBuffer2 = VBA.InStr(sReturn, "[")
'                                    sBuffer = sBuffer & VBA.Mid(sReturn, iBuffer + 5, iBuffer2 - iBuffer - 5)
'                                    sBuffer = sBuffer & " = new char"
'                                    For i = 0 To iCount - 1
'                                        sBuffer = sBuffer & "[" & a_sBracketContents(i) & "]"
'                                    Next i
'                                    sBuffer = sBuffer & ";"
'                                    iBuffer = VBA.InStr(sReturn, "char ")   'find start
'                                    iBuffer2 = VBA.InStr(sReturn, ";")
'                                    sReturn = sBuffer & VBA.Mid(sReturn, iBuffer2 + 1)
'                                End If
'                                Erase a_sBracketContents
'                            End If
'                        End If
                        If (VBA.InStr(sReturn, "[") > 0) And VBA.InStr(sReturn, "=") = 0 Then
                            a_sSplit = VBA.Split(Trim2(sReturn), " ")
                            If FindStringIndxInArray(a_sSplit(0), ga_sTypes) <> -1 Then  'if first word is a type
                                Dim iStart As Long
                                iStart = VBA.InStr(sReturn, a_sSplit(0))   'find start of code (after indents)
                                If IsInsideIgnoreSection(iStart, gaa_iIgnoreBounds) = False Then
                                    Dim a_sBracketContents(), iEnd As Long, iCount As Long
                                    bBuffer = False
                                    iBuffer = VBA.InStr(sReturn, "[")
                                    Do While ((iBuffer > 0) And (IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False))
                                        iBuffer2 = VBA.InStr(iBuffer + 1, sReturn, "]")
                                        If iBuffer2 > 0 Then
                                            iEnd = iBuffer2
                                        End If
                                        sBuffer = VBA.Mid(sReturn, iBuffer + 1, iBuffer2 - iBuffer - 1)
                                        Call PushArrayString(sBuffer, a_sBracketContents)
                                        iCount = iCount + 1
                                        If VBA.IsNumeric(sBuffer) = False Then
                                            If IsDynamicSize(sBuffer) = True Then
                                                bBuffer = True
                                            End If
                                        End If
                                        iBuffer = VBA.InStr(iBuffer2 + 1, sReturn, "[")
                                    Loop
                                    If bBuffer = True Then
                                        'start building new line
                                        sBuffer = VBA.Left(sReturn, iStart + VBA.Len(a_sSplit(0)) - 1)
                                        For i = 1 To iCount
                                            sBuffer = sBuffer & "[]"
                                        Next i
                                        sBuffer = sBuffer & " "
                                        'get variable name
                                        iBuffer2 = VBA.InStr(sReturn, "[")
                                        sBuffer = sBuffer & VBA.Mid(sReturn, iStart + VBA.Len(a_sSplit(0)) + 1, iBuffer2 - iStart - VBA.Len(a_sSplit(0)) - 1)
                                        sBuffer = sBuffer & " = new " & a_sSplit(0)
                                        For i = 0 To iCount - 1
                                            sBuffer = sBuffer & "[" & a_sBracketContents(i) & "]"
                                        Next i
                                        sBuffer = sBuffer & ";"
                                        iBuffer2 = VBA.InStr(sReturn, ";")  'find end so that we can get anything comments after it
                                        sReturn = sBuffer & VBA.Mid(sReturn, iBuffer2 + 1)
                                    End If
                                    Erase a_sBracketContents
                                End If
                            End If
                        End If
                    End If
                    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)     'Update "ignore" sections after replacement
                    
                    'save names of natives
                    iBuffer = VBA.InStr(sReturn, "CreateNative(")
                    If iBuffer > 0 Then
                        iBuffer = VBA.InStr(sReturn, "(")
                        If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                            iBuffer2 = VBA.InStr(sReturn, ")")
                            sBuffer = VBA.Mid(sReturn, iBuffer + 1, iBuffer2 - iBuffer - 1)
                            a_sSplit = VBA.Split(sBuffer, ",")
                            If FindStringIndxInArray(Trim2(VBA.Replace(a_sSplit(1), """", vbNullString)), ga_sTypes) = -1 Then
                                Call PushArrayString(Trim2(VBA.Replace(a_sSplit(1), """", vbNullString)), ga_sNativeFunctionNames)
                            End If
                        End If
                    End If
                    
                    'add enums to function types
                    iBuffer = VBA.InStr(sReturn, "enum ")
                    If iBuffer > 0 Then
                        If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                            sBuffer = Trim2(VBA.Replace(sReturn, "{", vbNullString))
                            sBuffer = StripComments(sBuffer, gaa_iCommentsOnly)
                            a_sSplit = VBA.Split(sBuffer, " ")
                            iCount = 0
                            For i = 0 To UBound(a_sSplit)   'processed this way in case there are multiple spaces, etc.
                                If a_sSplit(i) <> vbNullString Then
                                    iCount = iCount + 1
                                End If
                                If iCount = 2 Then
                                    sBuffer = a_sSplit(i)
                                    If FindStringIndxInArray(sBuffer, ga_sTypes) = -1 Then
                                        If sBuffer <> "const" Then
                                            Call PushArrayString(sBuffer, ga_sTypes)
                                        End If
                                    End If
                                    Exit For
                                End If
                            Next i
                        End If
                    End If

                    'TO DO: CONVERT TYPES INTO NEW SYNTAX CLASSES, BREAKING APART STRINGS AND RESTRUCTURING TO MAKE INTO NEW SYNTAX (SPECIFIC TO EACH CLASS).
                End If
            End If
        End If
    Else    'pre-compilation statement
        If VBA.Left(sReturn, 8) = "#include" Then  'assumes no leading tabs or spaces
            If g_sIncludePath <> vbNullString Then
                Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)
                sBuffer = StripComments(sReturn, gaa_iCommentsOnly)
                iBuffer = VBA.InStr(sBuffer, "<")
                bBuffer = False
                If iBuffer > 0 Then
                    iBuffer2 = VBA.InStr(sBuffer, ">")
                    sBuffer = VBA.Mid(sBuffer, iBuffer + 1, iBuffer2 - iBuffer - 1)
                    bBuffer = True
                Else    'path like #include "store/global.sp"
                    iBuffer = VBA.InStr(sBuffer, """")
                    iBuffer2 = VBA.InStr(iBuffer + 1, sBuffer, """")
                    If iBuffer2 > iBuffer + 1 Then  'if not empty quotes or quotes not found
                        sBuffer = VBA.Mid(sBuffer, iBuffer + 1, iBuffer2 - iBuffer - 1)
                        bBuffer = True
                    End If
                End If
                If bBuffer = True And sBuffer <> vbNullString Then
                    ProcessIncludes (sBuffer)
                End If
            End If
        ElseIf VBA.Left(sReturn, 7) = "#define" Then  'assumes no leading tabs or spaces
            Dim sDefineName As String
            Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)
            sBuffer = Trim2(StripComments(sReturn, gaa_iCommentsOnly))
            a_sSplit = SplitWithMultipleDelimiters(sBuffer, " (", True) 'space and tab as delimiters
            iCount = 0
            For i = 0 To UBound(a_sSplit)
                If a_sSplit(i) <> vbNullString Then
                    iCount = iCount + 1
                    If iCount = 2 Then
                        sDefineName = Trim2(a_sSplit(i))
                    ElseIf iCount = 3 Then
                        sBuffer = Trim2(a_sSplit(i))
                        Exit For
                    End If
                End If
            Next i
            If IsNumeric(sBuffer) = True Then
                If FindStringIndxInArray(sDefineName, ga_sNumericDefinedSizes) = -1 Then
                    Call PushArrayString(sDefineName, ga_sNumericDefinedSizes)
                End If
            End If
        End If
    End If

    ProcessLine = sReturn & sConvComm
    Call GetIgnoreSections(sOrigString, gaa_iIgnoreBounds, gaa_iCommentsOnly)    'Update "ignore" sections after replacement
    Call UpdateBracketCount(sReturn)
    
    If sTrimmedString <> vbNullString Then
        'save global variables for function type processing
        If g_iOpenBracketCount = 0 And g_bIsFunctionHeader = False Then
            a_sSplit = SplitWithMultipleDelimiters(Trim2(sReturn), " ", True)   'use SplitWithMultipleDelimiters because it will also remove multiple tabs/spaces next to each other, preventing blanks
            If IsArrayEmpty(a_sSplit) = False Then
                If FindStringIndxInArray(a_sSplit(0), ga_sTypes) <> -1 Then
                    Call Push2DStrArrayToArray(a_sSplit(1), a_sSplit(0), gaa_sGlobalVariables)
                End If
            End If
        End If
        
        'function type overrides - returned functions of specific types are not supported at this time
        iBuffer = VBA.InStr(sReturn, "return ")       'space on end indicates it is returning something other than void
        If iBuffer > 0 And (VBA.InStr(sReturn, ";") > 0) And (IsArrayEmpty(a_sOutputLines) = False) Then 'added check for ; to further filter out any weird circumstance where "return " may appear but it isnt a statement
            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                sBuffer = Trim2(VBA.Replace(sReturn, ";", vbNullString))
                If sBuffer = "return true" Or sBuffer = "return false" Then
                    Call OverrideFunctionType("bool")
                Else    'check if single variable
                    a_sSplit = SplitWithMultipleDelimiters(sBuffer, " ", True)
                    If IsArrayEmpty(a_sSplit) = False Then
                        If UBound(a_sSplit) = 1 Then    'if only 2 words
                            If (a_sSplit(1) <> "Plugin_Stop") And (a_sSplit(1) <> "Plugin_Continue") And (a_sSplit(1) <> "Plugin_Handled") And (a_sSplit(1) <> "Plugin_Changed") Then
                                If a_sSplit(1) = "true" Or a_sSplit(1) = "false" Then
                                    Call OverrideFunctionType("bool")
                                ElseIf VBA.IsNumeric(a_sSplit(1)) Then
                                    Call OverrideFunctionType("int")
                                ElseIf Get2DArrDataByIndx1StrMatch(gaa_sGlobalVariables, a_sSplit(1), 1) <> vbNullString Then    'if global variable
                                    Call OverrideFunctionType(Get2DArrDataByIndx1StrMatch(gaa_sGlobalVariables, a_sSplit(1), 1))
                                ElseIf FindStringIndxInArray(a_sSplit(1), ga_sNumericDefinedSizes) <> -1 Then  'if numeric defined size
                                    Call OverrideFunctionType("int")
                                Else    'check if variable in scope
                                    sbuffer2 = FindTypeOfVariableInFunction(a_sSplit(1))
                                    If sbuffer2 <> vbNullString Then
                                        Call OverrideFunctionType(sbuffer2)
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
End Function

Sub OverrideFunctionType(sType As String)
    Dim sBuffer As String, a_sSplit() As String, iBuffer As Long, sExistingType As String
    sBuffer = a_sOutputLines(0)
    iBuffer = VBA.InStr(sBuffer, "(")
    If iBuffer > 0 Then
        sBuffer = VBA.Left(sBuffer, iBuffer - 1)
        a_sSplit = SplitWithMultipleDelimiters(Trim2(sBuffer), " ", True)
        sExistingType = a_sSplit(UBound(a_sSplit) - 1)
        If sExistingType <> sType Then
            If FindStringIndxInArray(sExistingType, ga_sTypes) <> -1 Then   'checking if we actually grabbed a function type
                iBuffer = VBA.InStr(a_sOutputLines(0), sExistingType)
                a_sOutputLines(0) = VBA.Left(a_sOutputLines(0), iBuffer - 1) & sType & " " & VBA.Mid(a_sOutputLines(0), iBuffer + VBA.Len(sType) + 1)
                a_sOutputLines(0) = VBA.Replace(a_sOutputLines(0), sType & "  ", sType & " ")
            End If
        End If
    End If
End Sub

Sub ProcessIncludes(sIncludeName As String)
    Dim oFSO As Object, oIncFile As Object, sBuffer As String, sbuffer2 As String, iBuffer As Long, iBuffer2 As Long, sCodeBuffer As String
    Dim bBuffer As Boolean, a_iCommentsOnly(), a_iIgnoreBounds(), a_sSplit() As String
    If VBA.LCase(sIncludeName) <> "sourcemod" Then   'too much to process each time...these should be fairly static, so we will add them manually from a list, and not dynamically
        If FindStringIndxInArray(sIncludeName, ga_sIncludeNames) = -1 Then
            Set oFSO = CreateObject("Scripting.FileSystemObject")
            If oFSO.FileExists(g_sIncludePath & sIncludeName & ".inc") Then
                Call PushArrayString(sIncludeName, ga_sIncludeNames)
                Set oIncFile = oFSO.OpenTextFile(g_sIncludePath & sIncludeName & ".inc", ForReading)
                Do Until oIncFile.AtEndOfStream
                    sCodeBuffer = oIncFile.ReadLine
                    If VBA.Left(sCodeBuffer, 9) = "#include " Then  'recursive include processing
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)
                        sBuffer = StripComments(sCodeBuffer, a_iCommentsOnly)
                        iBuffer = VBA.InStr(sBuffer, "<")
                        bBuffer = False
                        If iBuffer > 0 Then
                            iBuffer2 = VBA.InStr(sBuffer, ">")
                            sBuffer = VBA.Mid(sBuffer, iBuffer + 1, iBuffer2 - iBuffer - 1)
                            bBuffer = True
                        Else    'paths like #include "store/global.sp"
                            iBuffer = VBA.InStr(sBuffer, """")
                            iBuffer2 = VBA.InStr(iBuffer, sBuffer, """")
                            If iBuffer2 > iBuffer + 1 Then
                                sBuffer = VBA.Mid(sBuffer, iBuffer + 1, iBuffer2 - iBuffer - 1)
                                bBuffer = True
                            End If
                        End If
                        ProcessIncludes (sBuffer)
                    ElseIf VBA.Left(sCodeBuffer, 8) = "#define " Then
                        If VBA.InStr(sCodeBuffer, "_included") = 0 Then
                            Dim sDefineName As String, iCount As Long, i As Long
                            'Filter out: #define _sourcemod_included or similar - convention is to have _included typically
                            Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)
                            sBuffer = Trim2(StripComments(sCodeBuffer, a_iCommentsOnly))
                            a_sSplit = SplitWithMultipleDelimiters(sBuffer, " (", True) 'space and tab as delimiters
                            iCount = 0
                            For i = 0 To UBound(a_sSplit)
                                If a_sSplit(i) <> vbNullString Then
                                    iCount = iCount + 1
                                    If iCount = 2 Then
                                        sDefineName = Trim2(a_sSplit(i))
                                    ElseIf iCount = 3 Then
                                        sBuffer = Trim2(a_sSplit(i))
                                        Exit For
                                    End If
                                End If
                            Next i
                            If IsNumeric(sBuffer) = True Then
                                If FindStringIndxInArray(sDefineName, ga_sNumericDefinedSizes) = -1 Then
                                    Call PushArrayString(sDefineName, ga_sNumericDefinedSizes)
                                End If
                            End If
                        End If
                    ElseIf VBA.InStr(sCodeBuffer, "enum ") > 0 Then 'add enums to function types
                        sBuffer = Trim2(VBA.Replace(sCodeBuffer, "{", vbNullString))
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to be able to use strip comments
                        sBuffer = StripComments(sBuffer, a_iCommentsOnly)
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to update lists in case ML comment in middle
                        iBuffer = VBA.InStr(sBuffer, "enum ")
                        If IsInsideIgnoreSection(iBuffer, a_iIgnoreBounds) = False Then
                            a_sSplit = VBA.Split(sBuffer, " ")
                            iCount = 0
                            For i = 0 To UBound(a_sSplit)   'processed this way in case there are multiple spaces, etc.
                                If a_sSplit(i) <> vbNullString Then
                                    iCount = iCount + 1
                                End If
                                If iCount = 2 Then
                                    sBuffer = a_sSplit(i)
                                    If FindStringIndxInArray(sBuffer, ga_sTypes) = -1 Then
                                        If sBuffer <> "const" Then
                                            Call PushArrayString(sBuffer, ga_sTypes)
                                        End If
                                    End If
                                    Exit For
                                End If
                            Next i
                        End If
                    ElseIf VBA.InStr(sCodeBuffer, "native ") > 0 Then 'add enums to function types
                        sBuffer = Trim2(sCodeBuffer)
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to be able to use strip comments
                        sBuffer = StripComments(sBuffer, a_iCommentsOnly)
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to update lists in case ML comment in middle
                        iBuffer = VBA.InStr(sBuffer, "native ")
                        If IsInsideIgnoreSection(iBuffer, a_iIgnoreBounds) = False Then
                            a_sSplit = SplitWithMultipleDelimiters(sBuffer, " (")
                            iCount = 0
                            For i = 0 To UBound(a_sSplit)   'processed this way in case there are multiple spaces, etc.
                                If a_sSplit(i) <> vbNullString Then
                                    iCount = iCount + 1
                                End If
                                If iCount = 2 Then
                                    If FindStringIndxInArray(Trim2(a_sSplit(i)), ga_sTypes) = -1 Then 'check for function type
                                        sBuffer = a_sSplit(i)
                                        If FindStringIndxInArray(sBuffer, ga_sNativeFunctionNames) = -1 Then
                                            Call PushArrayString(sBuffer, ga_sNativeFunctionNames)
                                        End If
                                        Exit For
                                    Else
                                        iCount = iCount - 1 'set back one
                                    End If
                                End If
                            Next i
                        End If
                    ElseIf VBA.InStr(sCodeBuffer, "forward ") > 0 Then 'add forwards to fwd types
                        sBuffer = Trim2(sCodeBuffer)
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to be able to use strip comments
                        sBuffer = StripComments(sBuffer, a_iCommentsOnly)
                        Call GetIgnoreSections(sCodeBuffer, a_iIgnoreBounds, a_iCommentsOnly)   'call to update lists in case ML comment in middle
                        iBuffer = VBA.InStr(sBuffer, "forward ")
                        If IsInsideIgnoreSection(iBuffer, a_iIgnoreBounds) = False Then
                            Dim sType As String
                            a_sSplit = SplitWithMultipleDelimiters(Trim2(sBuffer), " (", True)  'processed this way in case there are multiple spaces, etc.
                            iCount = 0
                            sType = "int"
                            For i = 0 To UBound(a_sSplit)
                                If a_sSplit(i) <> vbNullString Then
                                    iCount = iCount + 1
                                End If
                                If iCount = 2 Then
                                    If FindStringIndxInArray(Trim2(a_sSplit(i)), ga_sTypes) = -1 Then 'check for function type - if not, must be function name
                                        sBuffer = a_sSplit(i)
                                        If Get2DArrDataByIndx1StrMatch(gaa_sFwdNames, sBuffer, 1) = vbNullString Then
                                            Call Push2DStrArrayToArray(sBuffer, sType, gaa_sFwdNames)
                                        End If
                                        Exit For
                                    Else    'function type - set back one
                                        sType = Trim2(a_sSplit(i))
                                        iCount = iCount - 1 'set back one
                                    End If
                                End If
                            Next i
                        End If
                    End If
                Loop
                oIncFile.Close
            End If
        End If
    End If
    Set oFSO = Nothing
    Set oIncFile = Nothing
End Sub

Sub UpdateBracketCount(sText As String)
    Dim iBuffer As Long
    iBuffer = VBA.InStr(sText, "{")
    If iBuffer > 0 Then
        Do While iBuffer > 0
            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                g_iOpenBracketCount = g_iOpenBracketCount + 1
            End If
            iBuffer = VBA.InStr(iBuffer + 1, sText, "{")
        Loop
    End If
    
    iBuffer = VBA.InStr(sText, "}")
    If iBuffer > 0 Then
        Do While iBuffer > 0
            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                g_iOpenBracketCount = g_iOpenBracketCount - 1
            End If
            iBuffer = VBA.InStr(iBuffer + 1, sText, "}")
        Loop
    End If
End Sub

Function MakeReplacement(sFullString As String, sOrigText As String, sReplacement As String, bReplaceNewAlso As Boolean, iStartLoc As Long, ByRef aa_iIgnoreBounds() As Variant) As String
    Dim iBuffer As Long, sReturn As String
    sReturn = sFullString
    iBuffer = iStartLoc
    If bReplaceNewAlso = True Then
        sReturn = MakeReplacement(sReturn, "decl " & sOrigText, sReplacement, False, iStartLoc, aa_iIgnoreBounds)
        sReturn = MakeReplacement(sReturn, "decl" & vbTab & sOrigText, sReplacement, False, iStartLoc, aa_iIgnoreBounds) 'tab instead of space
        sReturn = MakeReplacement(sReturn, "new " & sOrigText, sReplacement, False, iStartLoc, aa_iIgnoreBounds)
        sReturn = MakeReplacement(sReturn, "new" & vbTab & sOrigText, sReplacement, False, iStartLoc, aa_iIgnoreBounds)  'tab instead of space
    End If
    iBuffer = VBA.InStr(iBuffer + 1, sReturn, sOrigText)
    If iBuffer > 0 Then
        Do While iBuffer > 0
            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
                sReturn = VBA.Left(sReturn, iBuffer - 1) & sReplacement & VBA.Mid(sReturn, iBuffer + VBA.Len(sOrigText))
            End If
            iBuffer = VBA.InStr(iBuffer + 1, sReturn, sOrigText)
        Loop
    End If
    MakeReplacement = sReturn
End Function

Sub GetIgnoreSections(sOrigString As String, ByRef a_iIgnoreBounds(), ByRef a_iCommentsOnly())
    Dim i As Long, bInQuotes As Boolean, iStart As Long, bSkip As Boolean, iBuffer As Long
    Erase a_iIgnoreBounds
    Erase a_iCommentsOnly
    iStart = 1
    If g_bMLCommentPrevLine = True Then
        iBuffer = VBA.InStr(sOrigString, "*/")
        If iBuffer <> 0 Then
            Call PushIntPairToArrays(iStart, iBuffer + 1, False, a_iIgnoreBounds, a_iCommentsOnly) 'end of ML quote
            iStart = iBuffer + 2
            g_bMLComment = False
        Else    'entire line is part of comment
            Call PushIntPairToArrays(iStart, VBA.Len(sOrigString), False, a_iIgnoreBounds, a_iCommentsOnly)
            Exit Sub
        End If
    End If
    
    If iStart <= VBA.Len(sOrigString) Then
        For i = iStart To VBA.Len(sOrigString)  'if the line didnt end on a closing ML quote
            bSkip = False
            If (bInQuotes = True) Then  'check for quotes
                If VBA.Mid(sOrigString, i, 1) <> """" Then  'middle of quote
                    bSkip = True
                Else
                    Call PushIntPairToArrays(iStart, i, False, a_iIgnoreBounds, a_iCommentsOnly)  'end of quote
                    bInQuotes = False
                    iStart = 1
                End If
            Else
                If VBA.Mid(sOrigString, i, 1) = """" Then   'start of quote
                    iStart = i
                    bInQuotes = True
                    bSkip = True
                End If
            End If
            
            If bSkip = False Then   'check for comments
                If i < VBA.Len(sOrigString) Then
                    If VBA.Mid(sOrigString, i, 2) = "//" Then
                        Call PushIntPairToArrays(i, VBA.Len(sOrigString), True, a_iIgnoreBounds, a_iCommentsOnly)
                        Exit For
                    ElseIf VBA.Mid(sOrigString, i, 2) = "/*" Then
                        iStart = i
                        i = i + 1   'increment so that it cannot be /*/
                        g_bMLComment = True
                        If VBA.InStr(i + 2, sOrigString, "*/") = 0 Then 'ML comment does not end on this line
                            Exit For
                        End If
                    ElseIf (VBA.Mid(sOrigString, i, 2) = "*/") And (g_bMLComment = True) Then
                        Call PushIntPairToArrays(iStart, i + 1, True, a_iIgnoreBounds, a_iCommentsOnly)
                        g_bMLComment = False
                        iStart = 1
                    End If
                End If
            End If
        Next i
    End If
End Sub

Sub CreateFunctionArray()
    Erase ga_sTypes
    Call PushArrayString("Action", ga_sTypes)
    Call PushArrayString("Address", ga_sTypes)
    Call PushArrayString("AdmAccessMode", ga_sTypes)
    Call PushArrayString("AdminCachePart", ga_sTypes)
    Call PushArrayString("AdminFlag", ga_sTypes)
    Call PushArrayString("AdminId", ga_sTypes)
    Call PushArrayString("any", ga_sTypes)
    Call PushArrayString("APLRes", ga_sTypes)
    Call PushArrayString("ArrayList", ga_sTypes)
    Call PushArrayString("ArrayStack", ga_sTypes)
    Call PushArrayString("AuthIdType", ga_sTypes)
    Call PushArrayString("BfRead", ga_sTypes)
    Call PushArrayString("BfWrite", ga_sTypes)
    Call PushArrayString("bool", ga_sTypes)
    Call PushArrayString("char", ga_sTypes)
    Call PushArrayString("ClientInfo", ga_sTypes)
    Call PushArrayString("ClientRangeType", ga_sTypes)
    Call PushArrayString("ConVar", ga_sTypes)
    Call PushArrayString("ConVarBounds", ga_sTypes)
    Call PushArrayString("ConVarQueryFinished", ga_sTypes)
    Call PushArrayString("ConVarQueryResult", ga_sTypes)
    Call PushArrayString("CookieAccess", ga_sTypes)
    Call PushArrayString("CookieMenu", ga_sTypes)
    Call PushArrayString("CookieMenuAction", ga_sTypes)
    Call PushArrayString("CSRoundEndReason", ga_sTypes)
    Call PushArrayString("CSWeaponID", ga_sTypes)
    Call PushArrayString("Database", ga_sTypes)
    Call PushArrayString("DataPackPos:", ga_sTypes)
    Call PushArrayString("DBBindType", ga_sTypes)
    Call PushArrayString("DBDriver", ga_sTypes)
    Call PushArrayString("DBPriority", ga_sTypes)
    Call PushArrayString("DBResult", ga_sTypes)
    Call PushArrayString("DBResultSet", ga_sTypes)
    Call PushArrayString("DBStatement", ga_sTypes)
    Call PushArrayString("DialogType", ga_sTypes)
    Call PushArrayString("DirectoryListing", ga_sTypes)
    Call PushArrayString("EngineVersion", ga_sTypes)
    Call PushArrayString("EventHook", ga_sTypes)
    Call PushArrayString("EventHookMode", ga_sTypes)
    Call PushArrayString("ExecType", ga_sTypes)
    Call PushArrayString("FeatureStatus", ga_sTypes)
    Call PushArrayString("FeatureType", ga_sTypes)
    Call PushArrayString("File", ga_sTypes)
    Call PushArrayString("FileTimeMode", ga_sTypes)
    Call PushArrayString("FileType", ga_sTypes)
    Call PushArrayString("FindMapResult", ga_sTypes)
    Call PushArrayString("float", ga_sTypes)
    Call PushArrayString("Float", ga_sTypes)
    Call PushArrayString("Function", ga_sTypes)
    Call PushArrayString("GroupId", ga_sTypes)
    Call PushArrayString("Handle", ga_sTypes)
    Call PushArrayString("Identity", ga_sTypes)
    Call PushArrayString("ImmunityType", ga_sTypes)
    Call PushArrayString("int", ga_sTypes)
    Call PushArrayString("KeyValues", ga_sTypes)
    Call PushArrayString("KvDataTypes", ga_sTypes)
    Call PushArrayString("ListenOverride", ga_sTypes)
    Call PushArrayString("MapChange", ga_sTypes)
    Call PushArrayString("Menu", ga_sTypes)
    Call PushArrayString("MenuAction", ga_sTypes)
    Call PushArrayString("MenuSource", ga_sTypes)
    Call PushArrayString("MenuStyle", ga_sTypes)
    Call PushArrayString("MoveType", ga_sTypes)
    Call PushArrayString("MsgHook", ga_sTypes)
    Call PushArrayString("NetFlow", ga_sTypes)
    Call PushArrayString("NominateResult", ga_sTypes)
    Call PushArrayString("NumberType", ga_sTypes)
    Call PushArrayString("OverrideRule", ga_sTypes)
    Call PushArrayString("OverrideType", ga_sTypes)
    Call PushArrayString("Panel", ga_sTypes)
    Call PushArrayString("ParamType", ga_sTypes)
    Call PushArrayString("PathType", ga_sTypes)
    Call PushArrayString("Plugin", ga_sTypes)
    Call PushArrayString("PluginInfo", ga_sTypes)
    Call PushArrayString("PluginStatus", ga_sTypes)
    Call PushArrayString("PropFieldType", ga_sTypes)
    Call PushArrayString("PropType", ga_sTypes)
    Call PushArrayString("Protobuf", ga_sTypes)
    Call PushArrayString("QueryCookie", ga_sTypes)
    Call PushArrayString("RayType", ga_sTypes)
    Call PushArrayString("Regex", ga_sTypes)
    Call PushArrayString("RegexError", ga_sTypes)
    Call PushArrayString("RenderFx", ga_sTypes)
    Call PushArrayString("RenderMode", ga_sTypes)
    Call PushArrayString("ReplySource", ga_sTypes)
    Call PushArrayString("RoundState", ga_sTypes)
    Call PushArrayString("SDKCallType", ga_sTypes)
    Call PushArrayString("SDKFuncConfSource", ga_sTypes)
    Call PushArrayString("SDKHookCB", ga_sTypes)
    Call PushArrayString("SDKHookType", ga_sTypes)
    Call PushArrayString("SDKLibrary", ga_sTypes)
    Call PushArrayString("SDKPassMethod", ga_sTypes)
    Call PushArrayString("SDKType", ga_sTypes)
    Call PushArrayString("SMCError", ga_sTypes)
    Call PushArrayString("SMCParser", ga_sTypes)
    Call PushArrayString("SMCResult", ga_sTypes)
    Call PushArrayString("SortFunc2D", ga_sTypes)
    Call PushArrayString("SortOrder", ga_sTypes)
    Call PushArrayString("SortType", ga_sTypes)
    Call PushArrayString("String", ga_sTypes)
    Call PushArrayString("StringMap", ga_sTypes)
    Call PushArrayString("StringMapSnapshot", ga_sTypes)
    Call PushArrayString("StudioAnimDesc", ga_sTypes)
    Call PushArrayString("StudioHdrClass", ga_sTypes)
    Call PushArrayString("TFClassType", ga_sTypes)
    Call PushArrayString("TFCond", ga_sTypes)
    Call PushArrayString("TFHoliday", ga_sTypes)
    Call PushArrayString("TFObjectMode", ga_sTypes)
    Call PushArrayString("TFObjectType", ga_sTypes)
    Call PushArrayString("TFResourceType", ga_sTypes)
    Call PushArrayString("TFTeam", ga_sTypes)
    Call PushArrayString("Timer", ga_sTypes)
    Call PushArrayString("TopMenu", ga_sTypes)
    Call PushArrayString("TopMenuAction", ga_sTypes)
    Call PushArrayString("TopMenuObject", ga_sTypes)
    Call PushArrayString("TopMenuObjectType", ga_sTypes)
    Call PushArrayString("TopMenuPosition", ga_sTypes)
    Call PushArrayString("TraceEntityFilter", ga_sTypes)
    Call PushArrayString("Transaction", ga_sTypes)
    Call PushArrayString("UserMessageType", ga_sTypes)
    Call PushArrayString("UserMsg", ga_sTypes)
    Call PushArrayString("UseType", ga_sTypes)
    Call PushArrayString("void", ga_sTypes)
    Call PushArrayString("WeaponModelInfo", ga_sTypes)
    Call PushArrayString("WeaponModelInfoStatus", ga_sTypes)
End Sub

Sub CreateNumericSizeDefinesArray() 'there may be others needing to be added
    Call PushArrayString("MAX_NAME_LENGTH", ga_sNumericDefinedSizes)
    Call PushArrayString("MAX_LIGHTSTYLES", ga_sNumericDefinedSizes)
    Call PushArrayString("MAX_TARGET_LENGTH", ga_sNumericDefinedSizes)
    Call PushArrayString("MAXPLAYERS", ga_sNumericDefinedSizes)
    Call PushArrayString("PLATFORM_MAX_PATH", ga_sNumericDefinedSizes)
    Call PushArrayString("MaxClients", ga_sNumericDefinedSizes)
End Sub

Sub Create2DFwdsArray()
    Call Push2DStrArrayToArray("OnLogAction", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientCommand", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("CS_OnBuyCommand", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientCommandKeyValues", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("CS_OnCSWeaponDrop", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("CS_OnGetWeaponPrice", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("CS_OnTerminateRound", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientPreAdminCheck", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnGetGameDescription", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnLevelInit", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_CalcIsAttackCritical", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnGetHoliday", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnIsHolidayActive", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnPlayerTeleport", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnBanClient", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnPlayerRunCmd", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientSayCommand", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnFileSend", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnBanIdentity", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnFileReceive", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnRemoveBan", "Action", gaa_sFwdNames)
    Call Push2DStrArrayToArray("AskPluginLoad2", "APLRes", gaa_sFwdNames)
    Call Push2DStrArrayToArray("AskPluginLoad", "bool", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientFloodCheck", "bool", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientConnect", "bool", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientPutInServer", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientDisconnect", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientDisconnect_Post", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnNominationRemoved", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnPluginEnd", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnMapVoteStarted", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnPluginPauseChange", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnGameFrame", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnMapStart", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientCookiesCached", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnMapEnd", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientCommandKeyValues_Post", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientSettingsChanged", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnConfigsExecuted", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnMapTimeLeftChanged", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientAuthorized", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnAutoConfigsBuffered", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnServerCfg", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnAllPluginsLoaded", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientPostAdminFilter", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientPostAdminCheck", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnEntityCreated", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnEntityDestroyed", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnRebuildAdminCache", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnConditionAdded", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnConditionRemoved", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnWaitingForPlayersStart", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("TF2_OnWaitingForPlayersEnd", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnLibraryAdded", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("BaseComm_OnClientMute", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnLibraryRemoved", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("BaseComm_OnClientGag", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientFloodResult", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientSayCommand_Post", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnAdminMenuCreated", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnAdminMenuReady", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnPluginStart", "void", gaa_sFwdNames)
    Call Push2DStrArrayToArray("OnClientConnected", "void", gaa_sFwdNames)
End Sub


