Attribute VB_Name = "modGenericFunctions"


'GenericFunctions Module

Option Explicit

Function SplitWithMultipleDelimiters(ByRef sText As String, ByRef sDelimChars As String, Optional bReplaceTabsWithSpace As Boolean = False, Optional bRemoveBlanks As Boolean = True) As String()
    Dim i As Long, sBuffer As String, sFirstDelim As String, sDelim As String
    sBuffer = sText
    sFirstDelim = VBA.Left$(sDelimChars, 1)
    If VBA.Len(sDelimChars) > 1 Then
        For i = 2 To VBA.Len(sDelimChars)
            sDelim = VBA.Mid$(sDelimChars, i, 1)
            sBuffer = VBA.Replace(sBuffer, sDelim, sFirstDelim)
        Next
    End If
    If bReplaceTabsWithSpace = True Then
        sBuffer = VBA.Replace(sBuffer, vbTab, " ")
    End If
    If bRemoveBlanks = True Then
        Do While VBA.InStr(sBuffer, sFirstDelim & sFirstDelim) > 0
            sBuffer = VBA.Replace(sBuffer, sFirstDelim & sFirstDelim, sFirstDelim)
        Loop
    End If
    SplitWithMultipleDelimiters = VBA.Split(sBuffer, sFirstDelim)
End Function

Function Trim2(sBuffer As String) As String
    Trim2 = VBA.Trim(VBA.Replace(sBuffer, vbTab, " "))
End Function

Function IsDynamicSize(sSizeText As String) As Boolean
    Dim i As Long, bReturn As Boolean, a_sSplit() As String, sBuffer As String
    bReturn = False
    a_sSplit = SplitWithMultipleDelimiters(sSizeText, "+-*/ ")
    If IsArrayEmpty(a_sSplit) = False Then
        For i = 0 To UBound(a_sSplit)
            sBuffer = Trim2(a_sSplit(i))
            If sBuffer <> vbNullString Then
                If VBA.IsNumeric(sBuffer) = False Then
                    If FindStringIndxInArray(sBuffer, ga_sNumericDefinedSizes) = -1 Then   'if text and not a saved numeric constant
                        bReturn = True
                        Exit For
                    End If
                End If
            End If
        Next i
    End If
    IsDynamicSize = bReturn
End Function

Function GetFunctionType(sFunctionName As String, Optional bMenuHandler As Boolean = False) As String
    Dim i As Long, sReturn As String, bFound As Boolean, sBuffer As String
    sReturn = "void"
    bFound = False
    If bMenuHandler = True Then
        sReturn = "int"
        bFound = True
    End If
    If bFound = False Then 'check if we
        If IsArrayEmpty(ga_sNativeFunctionNames) = False Then
            For i = 0 To UBound(ga_sNativeFunctionNames)
                If sFunctionName = ga_sNativeFunctionNames(i) Then
                    sReturn = "int"
                    bFound = True
                    Exit For
                End If
            Next i
        End If
        If bFound = False Then
            If IsArrayEmpty(gaa_sFwdNames) = False Then
                sBuffer = Get2DArrDataByIndx1StrMatch(gaa_sFwdNames, sFunctionName, 1)
                If sBuffer <> vbNullString Then
                    sReturn = sBuffer
                End If
            End If
        End If
    End If
    GetFunctionType = sReturn
End Function

'Function HandleHeaderCharParams(sText As String) As String
'    Dim iBuffer As Long, sBuffer As String, sReturn As String, iEnd As Long
'    sReturn = sText
'    iBuffer = VBA.InStr(iBuffer + 1, sReturn, "String:")
'    If iBuffer > 0 Then
'        Do While iBuffer > 0
'            If IsInsideIgnoreSection(iBuffer, gaa_iIgnoreBounds) = False Then
'                iEnd = iBuffer
'                iEnd = VBA.InStr(iEnd + 1, sReturn, ",")
'                If iEnd = 0 Then
'                    iEnd = VBA.InStr(iEnd + 1, sReturn, ")")
'                End If
'                'iEnd should be populated now
'                sReturn = VBA.Left(sReturn, iEnd - 3) & VBA.Mid(sReturn, iEnd)
'            End If
'            iBuffer = VBA.InStr(iBuffer + 1, sText, "String:")
'        Loop
'    End If
'    sReturn = VBA.Replace(sReturn, "String:", "char[] ")
'    HandleHeaderCharParams = sReturn
'End Function

Function IsFunctionHeader(sOrigString As String) As Boolean   'doesnt end in ; or { and next line isnt { or cond compile statement
    Dim sBuffer As String, bReturn As Boolean, sLastChar As String
    bReturn = False
    sBuffer = Trim2(StripComments(sOrigString, gaa_iCommentsOnly))
    If g_iOpenBracketCount = 0 Then
        sLastChar = VBA.Right(sBuffer, 1)
        If sLastChar = "{" Then
            bReturn = True
        ElseIf sLastChar <> ";" Then
            If Trim2(g_sNextLine) = "{" Then
                bReturn = True
            End If
        End If
    End If
    IsFunctionHeader = bReturn
End Function

Function StripComments(sCode As String, ByRef a_iCommentsOnly()) As String
    Dim sReturn As String, i As Long, a_iTemp
    sReturn = sCode
    If IsArrayEmpty(a_iCommentsOnly) = False Then
        For i = UBound(a_iCommentsOnly) To 0 Step -1
            a_iTemp = a_iCommentsOnly(i)
            sReturn = VBA.Left(sReturn, VBA.Len(sReturn) - (a_iTemp(1) - a_iTemp(0) + 1))
        Next i
    End If
    StripComments = sReturn
End Function

Function IsInsideIgnoreSection(iCharIndex As Long, ByRef a_iIgnoreBounds) As Boolean
    Dim i As Long, bRtn As Boolean, a_iTemp
    bRtn = False
    If IsArrayEmpty(a_iIgnoreBounds) = False Then
        a_iTemp = a_iIgnoreBounds(i)
        For i = 0 To UBound(a_iIgnoreBounds)
            If (iCharIndex >= a_iTemp(0)) And (iCharIndex <= a_iTemp(1)) Then
                bRtn = True
                Exit For
            End If
        Next i
    End If

    IsInsideIgnoreSection = bRtn
End Function

Function FindTypeOfVariableInFunction(sVariableName As String) As String
    Dim i As Long, sReturn As String, sBuffer As String, a_sSplit() As String, j As Long
    If IsArrayEmpty(a_sOutputLines) = False Then
        For i = 0 To UBound(a_sOutputLines)
            If VBA.InStr(a_sOutputLines(i), sVariableName) > 0 Then
                a_sSplit = SplitWithMultipleDelimiters(Trim2(VBA.CStr(a_sOutputLines(i))), " ,", True)
                For j = 1 To UBound(a_sSplit)
                    If a_sSplit(j) = sVariableName Then
                        If FindStringIndxInArray(a_sSplit(j - 1), ga_sTypes) <> -1 Then
                            sReturn = a_sSplit(j - 1)
                            GoTo ReturnFound
                        End If
                    End If
                Next j
            End If
        Next i
    End If
ReturnFound:
    FindTypeOfVariableInFunction = sReturn
End Function

Function GetLeadingIndents(sText As String) As String
    Dim iBuffer As Long, sReturn As String
    iBuffer = VBA.InStr(sText, Trim2(sText))
    If iBuffer > 0 Then
        sReturn = VBA.Left(sText, iBuffer - 1)
    Else
        sReturn = vbNullString
    End If
    GetLeadingIndents = sReturn
End Function


